<div>
    <form [formGroup]="searchForm" class="form">
        <mat-form-field appearance="standard">
            <mat-label>Search by name</mat-label>
            <input type="text" aria-label="Input name" matInput formControlName="name" (keyup)="search()">
        </mat-form-field>
        <mat-form-field appearance="standard">
            <mat-label>Search by author</mat-label>
            <input type="text" aria-label="Input author" matInput formControlName="author" (keyup)="search()">
        </mat-form-field>
        <mat-form-field appearance="standard">
            <mat-label>Search by price</mat-label>
            <input type="text" aria-label="Input price" matInput formControlName="price" (keyup)="search()">
        </mat-form-field>
    </form>

    <div class="mat-elevation-z8">
        <table mat-table [dataSource]="postsDataSource" matSort>
            <ng-container matColumnDef="name">
                <th mat-header-cell *matHeaderCellDef mat-sort-header>
                    Name
                </th>
                <td mat-cell *matCellDef="let row"> {{row.name}} </td>
            </ng-container>

            <ng-container matColumnDef="author">
                <th mat-header-cell *matHeaderCellDef mat-sort-header>
                    Author
                </th>
                <td mat-cell *matCellDef="let row"> {{row.author}} </td>
            </ng-container>

            <ng-container matColumnDef="price">
                <th mat-header-cell *matHeaderCellDef mat-sort-header>
                    Price
                </th>
                <td mat-cell *matCellDef="let row "> {{row.price}} </td>
            </ng-container>

            <tr mat-header-row *matHeaderRowDef="postProps"></tr>
            <tr mat-row *matRowDef="let row; columns: postProps;"></tr>
        </table>

        <mat-paginator [pageSizeOptions]="[5, 10, 25]" aria-label="Select page of users"></mat-paginator>
    </div>
</div>